// 
unit ServerClassUnit;

interface

uses Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, IniFiles,
  Winsock, IdUDPClient, IdStack, StrUtils;

type

  TServerClass = class
    sc_dataFileName: string; // f[^t@C
    sc_backupFileName: string; // obNAbvt@C
    sc_backupIntervalTime: integer; // obNAbvԊuiԁj
    sc_dataPreservationDays: integer; // f[^ۑ
    sc_backupPreservationDays: integer; // obNAbvۑ
    sc_groupName: string; // O[v@J}؂
    sc_pcNameCheck: integer; // p\R@0: 1:Liݒ蔽fj 2:Liother:gpsj
    sc_macAddrCheck: integer; // MACAhX 0: 1:L
    sc_logDeleteDays: integer; // OۊǓ
    sc_autoStart: integer; // X^[g@0:X^[g 1:蓮X^[g
    sc_pcCheckFileName: string; // PCt@C
    sc_macAddrCheckFileName: string; // MACAhXt@C
    sc_logFileName: string; // Ot@C
    sc_port: integer; // |[gԍ
    activePcList: TstringList; // gpPCXg
  private
  public
    constructor create;
    procedure iniFileRead; // T[oinit@C̓ǂݍ
    procedure iniFileWrite; // T[oinit@C̏o
    function backup(): boolean; // obNAbv
    function csvValue(str: string; n: integer): string; // csveLXg̒lo
    function DeleteMsg(dateTime: TDateTime; randam: integer): boolean;
    // bZ[W폜
    function getCheckMsgList(dateTime: TDateTime; groupName: string;
      macAddr: String; ipAddr: string; hostName: string; sender: string)
      : TstringList; // bZ[W̓o
    function getFullMsgList(reduce: boolean): TstringList;
    // SbZ[W̎擾(NOWȉŒoL)
    function GetHostName(): string; // zXgiPCj̎擾
    function GetIpAdress(): string; // IPAhX̎擾
    function GetMACAdress(IPAddress: string): string; // MACAhX̎擾
    // function MessageList(): TStringList; // bZ[Wꗗ
    function MsgList(var SL: TstringList): TstringList; // bZ[Wꗗ
    function pcCheck(pcName: string; macAddr: string; ipAddr: string): integer;
    // PC
    function registMessage(MSG: TstringList): boolean; // bZ[Wo^
    function unyolog(pcName: string; macAddr: string; ipAddr: string;
      MSG: string): boolean; // Oo
    function unyolog2(MSG: string): boolean; // Oo
    function MemoToText(aMemo: string): string;
    function TextToMemo(aText: string): string;

  end;

implementation

constructor TServerClass.create;
// ==========================================================================//
// RXgN^[
// ==========================================================================//
begin
  inherited;
  activePcList := TstringList.create;
end;

procedure TServerClass.iniFileRead;
// ==========================================================================//
// ini file ǂݍ
// ==========================================================================//
var
  Ini: TIniFile;
begin
  Ini := TIniFile.create(ChangeFileExt(Application.ExeName, '.ini'));
  try
    sc_dataFileName := Ini.ReadString('mintServer', 'dataFileName',
      'mint_data.txt');
    sc_backupFileName := Ini.ReadString('mintServer', 'backupFileName',
      'mint_backup.txt');
    sc_backupIntervalTime := Ini.ReadInteger('mintServer',
      'backupIntervalTime', 1);
    sc_dataPreservationDays := Ini.ReadInteger('mintServer',
      'dataPreservationDays', 3);
    sc_backupPreservationDays := Ini.ReadInteger('mintServer',
      'backupPreservationDayse', 400);
    sc_groupName := Ini.ReadString('mintServer', 'groupName', 'O[v`,O[va');
    sc_pcNameCheck := Ini.ReadInteger('mintServer', 'pcNameCheck', 0);
    sc_macAddrCheck := Ini.ReadInteger('mintServer', 'macAddrCheck', 0);
    sc_logDeleteDays := Ini.ReadInteger('mintServer', 'logDeleteDays', 90);
    sc_autoStart := Ini.ReadInteger('mintServer', 'autoStart', 0);
    sc_pcCheckFileName := Ini.ReadString('mintServer', 'pcCheckFileName',
      'mint_pccheck.txt');
    sc_macAddrCheckFileName := Ini.ReadString('mintServer',
      'macAddrCheckFileName', 'mint_macaddr.txt');
    sc_logFileName := Ini.ReadString('mintServer', 'logFileName',
      'mint_logfile.txt');
    sc_port := Ini.ReadInteger('mintServer', 'port', 8070);
  finally
    Ini.Free
  end;
end;

procedure TServerClass.iniFileWrite;
// ==========================================================================//
// ini file 
// ==========================================================================//
var
  Ini: TIniFile;
begin
  Ini := TIniFile.create(ChangeFileExt(Application.ExeName, '.ini'));
  try
    Ini.WriteString('mintServer', 'dataFileName', sc_dataFileName);
    Ini.WriteString('mintServer', 'backupFileName', sc_backupFileName);
    Ini.WriteInteger('mintServer', 'backupIntervalTime', sc_backupIntervalTime);
    Ini.WriteInteger('mintServer', 'dataPreservationDays',
      sc_dataPreservationDays);
    Ini.WriteInteger('mintServer', 'backupPreservationDays',
      sc_backupPreservationDays);
    Ini.WriteString('mintServer', 'groupName', sc_groupName);
    Ini.WriteInteger('mintServer', 'pcNameCheck', sc_pcNameCheck);
    Ini.WriteInteger('mintServer', 'macAddrCheck', sc_macAddrCheck);
    Ini.WriteInteger('mintServer', 'logDeleteDays', sc_logDeleteDays);
    Ini.WriteInteger('mintServer', 'autoStart', sc_autoStart);
    Ini.WriteString('mintServer', 'pcCheckFileName', sc_pcCheckFileName);
    Ini.WriteString('mintServer', 'macAddrCheckFileName',
      sc_macAddrCheckFileName);
    Ini.WriteString('mintServer', 'logFileName', sc_logFileName);
    Ini.WriteInteger('mintServer', 'port', sc_port);
  finally
    Ini.Free
  end;
end;

const
  NewLine = #13#10;
  EncCode = #12;

function TServerClass.MemoToText(aMemo: string): string;
// ==========================================================================//
// s̕ϊ
// ==========================================================================//
var
  aBuff: string;
  cnt: integer;
begin
  result := '';
  aBuff := TrimRight(AdjustLineBreaks(aMemo));
  for cnt := 1 to length(aBuff) do
    begin
      if IsDelimiter(NewLine, aBuff, cnt) then
        begin
          if Copy(aBuff, cnt, 1) = #13 then
            result := result + EncCode;
        end
      else
        begin
          result := result + Copy(aBuff, cnt, 1);
        end;
    end;
end;

function TServerClass.TextToMemo(aText: string): string;
// ==========================================================================//
// s̖߂
// ==========================================================================//
var
  aBuff: string;
  cnt: integer;
begin
  aBuff := '';
  for cnt := 1 to length(aText) do
    begin
      if IsDelimiter(EncCode, aText, cnt) then
        aBuff := aBuff + NewLine
      else
        aBuff := aBuff + Copy(aText, cnt, 1);
    end;
  result := aBuff;
end;

function TServerClass.registMessage(MSG: TstringList): boolean;
// ==========================================================================//
// bZ[W̏
// ==========================================================================//
var
  DF: TextFile;
  SL: TstringList;
  buf: string;

begin
  result := false;
  try
    AssignFile(DF, sc_dataFileName);
    SL := TstringList.create;
    Append(DF);
    SL.Delimiter := #9; // TAB
    SL.Clear;
    SL.Add(''); // 0
    SL.Add(MSG.Values['dateTime']); // 1
    SL.Add(MSG.Values['dataType']); // 2
    SL.Add(MemoToText(LeftStr(MSG.Values['messageText'], 4000))); // 3
    SL.Add(MSG.Values['groupName']); // 4
    SL.Add(MSG.Values['keyword']); // 5
    SL.Add(MSG.Values['level']); // 6
    SL.Add(MSG.Values['randam']); // 7
    SL.Add(MSG.Values['pcName']); // 8
    SL.Add(MSG.Values['macAddr']); // 9
    SL.Add(MSG.Values['ipAddr']); // 10
    SL.Add(MSG.Values['senderName']); // 11
    buf := SL.DelimitedText;
    WriteLn(DF, buf);
    CloseFile(DF);
    result := true;
  finally
    SL.Free;
  end;
end;

function TServerClass.unyolog(pcName, macAddr, ipAddr, MSG: string): boolean;
// ==========================================================================//
// Oo
// ==========================================================================//
var
  DF: TextFile;
  SL: TstringList;
  buf: string;

begin
  result := false;

  if FileExists(sc_logFileName) then
  else
    begin
      AssignFile(DF, sc_logFileName);
      Rewrite(DF);
      CloseFile(DF);
    end;

  try
    AssignFile(DF, sc_logFileName);
    SL := TstringList.create;
    Append(DF);
    SL.Delimiter := #9; // TAB
    SL.StrictDelimiter := true;
    SL.Clear;
    SL.Add(FormatDateTime('yyyy/mm/dd hh:mm:ss', now)); // 1
    SL.Add(pcName); // 2
    SL.Add(ipAddr); // 3
    SL.Add(macAddr); // 4
    SL.Add(MemoToText(MSG)); // 5
    buf := SL.DelimitedText;
    buf := AnsiReplaceStr(buf, '"', '');
    WriteLn(DF, buf);
    CloseFile(DF);
    result := true;
  finally
    SL.Free;
  end;

end;

function TServerClass.unyolog2(MSG: string): boolean;
// ==========================================================================//
// Oó@p
// ==========================================================================//
begin
  unyolog(GetHostName, GetMACAdress(GetIpAdress), GetIpAdress, MSG);
end;

function CustomSortASC(List: TstringList; Index1, Index2: integer): integer;
// ==========================================================================//
// JX^\[g  \[g
// ==========================================================================//
begin
  // result := AnsiCompareStr(List[Index1], List[Index2]); // P[l/啶
  result := CompareStr(List[Index1], List[Index2]);
  // P[/啶
  // result := AnsiCompareText(List[Index1], List[Index2]); // P[l/啶
  // result := CompareText(List[Index1], List[Index2]); // P[/啶
end;

function CustomSortDESC(List: TstringList; Index1, Index2: integer): integer;
// ==========================================================================//
// JX^\[g  ~\[g
// ==========================================================================//
begin
  // result := -AnsiCompareStr(List[Index1], List[Index2]); // P[l/啶
  result := -CompareStr(List[Index1], List[Index2]);
  // P[/啶
  // result := -AnsiCompareText(List[Index1], List[Index2]); // P[l/啶
  // result := -CompareText(List[Index1], List[Index2]); // P[/啶
end;

function TServerClass.getFullMsgList(reduce: boolean): TstringList;
// ==========================================================================//
// SbZ[W擾@_܂łŒo
// ==========================================================================//
var
  SF: TextFile;
  SL: TstringList;
  buf: string;
begin

  if FileExists(sc_dataFileName) then
  else
    begin
      AssignFile(SF, sc_dataFileName);
      Rewrite(SF);
      CloseFile(SF);
    end;

  try
    AssignFile(SF, sc_dataFileName);
    SL := TstringList.create;
    Reset(SF);
    while not eof(SF) do
      begin
        ReadLn(SF, buf);
        if csvValue(buf, 0) = '' then
          begin
            if reduce = true then
              begin
                if StrToDateTime(csvValue(buf, 1)) <= now then
                  SL.Add(buf);
              end
            else
              SL.Add(buf);
          end;
      end;
    CloseFile(SF);
    result := SL;
  finally
    // SL.Free;
  end;
end;

function TServerClass.DeleteMsg(dateTime: TDateTime; randam: integer): boolean;
// ==========================================================================//
// bZ[W폜
// ==========================================================================//
var
  SL: TstringList;
  I: integer;
begin
  result := false;
  SL := getFullMsgList(false); // S擾
  for I := 0 to SL.Count - 1 do
    if (StrToDateTime(csvValue(SL.Strings[I], 1)) = dateTime) and
      (StrToInt(csvValue(SL.Strings[I], 7)) = randam) then
      begin
        SL.Delete(I);
        result := true;
        break;
      end;
  SL.SaveToFile(sc_dataFileName);
  SL.Free;
end;

function TServerClass.getCheckMsgList(dateTime: TDateTime; groupName: string;
  macAddr: String; ipAddr: string; hostName: string; sender: string)
  : TstringList;
// ==========================================================================//
// bZ[W̓o
// ==========================================================================//
var
  SF: TextFile;
  SL, SL2, pcInfo: TstringList;
  buf: string;
  I: integer;
begin

  if FileExists(sc_dataFileName) then
  else
    begin
      AssignFile(SF, sc_dataFileName);
      Rewrite(SF);
      CloseFile(SF);
    end;

  AssignFile(SF, sc_dataFileName);
  SL := TstringList.create;
  SL2 := TstringList.create;
  Reset(SF);
  while not eof(SF) do
    begin
      ReadLn(SF, buf);
      if csvValue(buf, 0) = '' then
        if (StrToDateTime(csvValue(buf, 1)) >= dateTime) and
          (StrToDateTime(csvValue(buf, 1)) <= now) then
          SL.Add(buf);
    end;
  CloseFile(SF);

  if (groupName = '') or (groupName = 'SO[v') then
    result := SL
  else
    begin
      for I := 0 to SL.Count - 1 do
        if (csvValue(SL.Strings[I], 4) = '') or
          (csvValue(SL.Strings[I], 4) = 'SO[v') or
          (csvValue(SL.Strings[I], 4) = groupName) then
          SL2.Add(SL.Strings[I]);
      result := SL2;
    end;

  // gpPCXg̍쐬
  pcInfo := TstringList.create;
  pcInfo.Values['dateTime'] := FormatDateTime('yyyy/mm/dd hh:mm:ss', now);
  pcInfo.Values['hostName'] := hostName;
  pcInfo.Values['macAddr'] := macAddr;
  pcInfo.Values['ipAddr'] := ipAddr;
  pcInfo.Values['sender'] := sender;

  if activePcList.Values[macAddr] = '' then
    unyolog(pcInfo.Values['hostName'], pcInfo.Values['macAddr'],
      pcInfo.Values['ipAddr'], pcInfo.Values['sender'] + ' Connection Start');

  activePcList.Values[macAddr] := pcInfo.Text;
  pcInfo.Free;

end;

function TServerClass.MsgList(var SL: TstringList): TstringList;
// ==========================================================================//
// bZ[WXg쐬  ͋t@i͂SLtɃ\[gj
// ==========================================================================//
var
  ML: TstringList;
  I: integer;
  buf: string;
begin
  try
    ML := TstringList.create;
    SL.CustomSort(CustomSortDESC); // ~\[g
    for I := 0 to SL.Count - 1 do
      begin
        buf := SL.Strings[I];
        ML.Add('' + csvValue(buf, 1) + ' [' + csvValue(buf, 4) + '] ' +
          csvValue(buf, 5) + '@' + ' MҁF' + csvValue(buf, 11) + #9#13#10 +
          TextToMemo(csvValue(buf, 3)));
      end;
    result := ML;
  finally
    // ML.Free;
  end;

end;

function TServerClass.pcCheck(pcName, macAddr, ipAddr: string): integer;
var
  SF: TextFile;
  SL: TstringList; // SL1:ۑ@SL2F폜
  buf: string;
  I: integer;
  flag: boolean; // tO@false:G[@true:OK
begin
  // ==========================================================================//
  // PC
  // ==========================================================================//
  // sc_pcCheckFileName
  // sc_macAddrCheckFileName
  // sc_pcNameCheck
  // sc_macAddrCheck

  // error flag
  // 1 pcname no check
  // 2 macaddr no check
  // 4 pcname error
  // 8 macaddr error
  //
  // 0@OK
  // 1@pcname no check
  // 2  macaddr no check
  // 3  pcname,macaddr no check
  // -----------------------------------
  // 4  pcname error ,macaddr OK
  // 6  pcname error , macaddr no check
  // 8@macaddr error ,pcname ok
  // 9  macaddr error ,pcname no check
  // 12 pcname error,macaddr error

  if FileExists(sc_pcCheckFileName) then
  else
    begin
      AssignFile(SF, sc_pcCheckFileName);
      Rewrite(SF);
      CloseFile(SF);
    end;

  if FileExists(sc_macAddrCheckFileName) then
  else
    begin
      AssignFile(SF, sc_macAddrCheckFileName);
      Rewrite(SF);
      CloseFile(SF);
    end;

  result := 0;

  if sc_pcNameCheck = 0 then
    begin
      result := result + 1;
    end
  else
    begin
      flag := false;
      SL := TstringList.create;
      SL.LoadFromFile(sc_pcCheckFileName);
      for I := 0 to SL.Count - 1 do
        if LeftStr(LowerCase(pcName), length(SL.Strings[I]))
          = LowerCase(SL.Strings[I]) then
          begin
            flag := true;
            break;
          end;
      if flag = false then
        result := result + 4;
      SL.Free;
    end;

  if sc_macAddrCheck = 0 then
    begin
      result := result + 2;
    end
  else
    begin
      flag := false;
      SL := TstringList.create;
      SL.LoadFromFile(sc_macAddrCheckFileName);
      for I := 0 to SL.Count - 1 do
        if LowerCase(macAddr) = LeftStr(LowerCase(SL.Strings[I]), 17) then
          begin
            flag := true;
            break;
          end;
      if flag = false then
        result := result + 8;
      SL.Free;
    end;;

  unyolog(pcName, macAddr, ipAddr, 'PcCheck result:' + inttostr(result));
end;

function TServerClass.backup: boolean;
// ==========================================================================//
// obNAbv
// ==========================================================================//
var
  SF: TextFile;
  SL1, SL2: TstringList; // SL1:ۑ@SL2F폜
  dt1, dt2, dt3: TDateTime; // DT1Ff[^ۑADT2FobNAbvۑ
  buf: string;
  I: integer;
begin
  dt1 := now - sc_dataPreservationDays;
  dt2 := now - sc_backupPreservationDays;
  dt3 := now - sc_logDeleteDays;

  // obNAbvt@C̐
  if FileExists(sc_backupFileName) then
    begin
      try
        AssignFile(SF, sc_backupFileName);
        SL1 := TstringList.create;
        SL2 := TstringList.create;
        Reset(SF);
        while not eof(SF) do
          begin
            ReadLn(SF, buf);
            if csvValue(buf, 0) = '' then
              if StrToDateTime(csvValue(buf, 1)) >= dt2 then
                SL1.Add(buf)
              else
                SL2.Add(buf);
          end;
        CloseFile(SF);
        SL1.SaveToFile(sc_backupFileName);
      finally
        SL1.Free;
        SL2.Free;
      end;
    end
  else
    begin
      AssignFile(SF, sc_backupFileName);
      Rewrite(SF);
      CloseFile(SF);
      result := false;
    end;

  // f[^t@C̐
  if FileExists(sc_dataFileName) then
    begin
      try
        AssignFile(SF, sc_dataFileName);
        SL1 := TstringList.create;
        SL2 := TstringList.create;
        Reset(SF);
        while not eof(SF) do
          begin
            ReadLn(SF, buf);
            if csvValue(buf, 0) = '' then
              if StrToDateTime(csvValue(buf, 1)) >= dt1 then
                SL1.Add(buf)
              else
                SL2.Add(buf);
          end;
        CloseFile(SF);

        // f[^t@CۑAobNAbvt@Cւ̒ǉ
        if SL2.Count > 0 then
          begin
            SL1.Sort;
            SL1.SaveToFile(sc_dataFileName);
            SL1.LoadFromFile(sc_backupFileName);
            for I := 0 to SL2.Count - 1 do
              SL1.Add(SL2.Strings[I]);
            SL1.SaveToFile(sc_backupFileName);
          end;

      finally
        SL1.Free;
        SL2.Free;
      end;
    end
  else
    begin
      AssignFile(SF, sc_dataFileName);
      Rewrite(SF);
      CloseFile(SF);
      result := false;
    end;

  // Ot@C̐
  if FileExists(sc_logFileName) then
    begin
      try
        AssignFile(SF, sc_logFileName);
        SL1 := TstringList.create;
        SL2 := TstringList.create;
        Reset(SF);
        while not eof(SF) do
          begin
            ReadLn(SF, buf);
            if csvValue(buf, 0) = '' then
              if StrToDateTime(csvValue(buf, 0)) >= dt3 then
                SL1.Add(buf)
              else
                SL2.Add(buf);
          end;
        CloseFile(SF);

        if SL2.Count > 0 then
          begin
            SL1.SaveToFile(sc_logFileName);
          end;

      finally
        SL1.Free;
        SL2.Free;
      end;
    end
  else
    begin
      AssignFile(SF, sc_logFileName);
      Rewrite(SF);
      CloseFile(SF);
      result := false;
    end;
end;

function TServerClass.csvValue(str: string; n: integer): string;
// ==========================================================================//
// CSVeLXg炎Ԗڂ̒l擾
// ==========================================================================//
var
  CL: TstringList;
begin
  CL := TstringList.create;
  CL.Delimiter := #9; // TAB
  CL.StrictDelimiter := true;
  CL.DelimitedText := str;
  if CL.Count <= n then
    result := ''
  else
    result := CL.Strings[n];
  CL.Free;
end;

function TServerClass.GetIpAdress(): string;
// ==========================================================================//
// IPAhX̎擾
// ==========================================================================//
var
  IdUDP: TIdUDPClient;
begin
  IdUDP := TIdUDPClient.create(nil);
  result := GStack.LocalAddress;
  IdUDP.Free;
end;

function TServerClass.GetHostName(): string;
// ==========================================================================//
// zXgiPCj̎擾
// ==========================================================================//
var
  IdUDP: TIdUDPClient;
begin
  IdUDP := TIdUDPClient.create(nil);
  result := GStack.hostName;
  IdUDP.Free;
end;

function SendARP(DestIp: DWORD; srcIP: DWORD; pMacAddr: pointer;
  PhyAddrLen: pointer): DWORD; stdcall; external 'iphlpapi.dll';
// ==========================================================================//
// IPAhXMACAhX̎擾[`@}CN\tg
// ==========================================================================//

function TServerClass.GetMACAdress(IPAddress: string): string;
// ==========================================================================//
// MACAhX̎擾
// ==========================================================================//
var
  MACAddress: string;
  RC: DWORD;
  AnsiIPAddress: AnsiString;
  dwRemoteIP: DWORD;
  PhyAddrLen: Longword;
  pMacAddr: array [0 .. 1] of Longword;
  temp: array [0 .. 5] of Byte;
  I: Byte;
begin
  result := '';
  AnsiIPAddress := AnsiString(IPAddress);
  dwRemoteIP := inet_addr(PAnsiChar(AnsiIPAddress));
  if dwRemoteIP <> 0 then
    begin
      PhyAddrLen := 6;
      RC := SendARP(dwRemoteIP, 0, @pMacAddr, @PhyAddrLen);
      if RC = NO_ERROR then
        begin
          if (PhyAddrLen <> 0) and (pMacAddr[0] <> 0) then
            begin
              Move(pMacAddr, temp, 6);
              MACAddress := '';
              for I := 0 to PhyAddrLen - 1 do
                begin
                  MACAddress := MACAddress + IntToHex(temp[I], 2) + '-';
                end;
              Delete(MACAddress, length(MACAddress), 1);
              result := MACAddress;
            end;
        end;
    end;
end;

end.
