// 
unit ServerConfigUnit;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ComCtrls,
  Vcl.ExtCtrls, ServerContainerUnit1,
  ShlObj, ActiveX, ComObj;

type
  Tfm_ServerConfig = class(TForm)
    bt_cancel: TButton;
    bt_ok: TButton;
    Edit_backupFileName: TEdit;
    Edit_backupIntervalTime: TComboBox;
    Edit_backupPreservationDays: TComboBox;
    Edit_dataFileName: TEdit;
    Edit_dataPreservationDays: TComboBox;
    Edit_logDaleteDays: TComboBox;
    Edit_logFileName: TEdit;
    Edit_macAddrCheck: TComboBox;
    Edit_macAddrCheckFile: TEdit;
    Edit_pcNameCheck: TComboBox;
    Edit_pcNameCheckFile: TEdit;
    Edit_port: TComboBox;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    mm_groupName: TMemo;
    bt_startup: TButton;
    procedure FormCreate(Sender: TObject);
    procedure bt_okClick(Sender: TObject);
    procedure bt_cancelClick(Sender: TObject);
    procedure bt_startupClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  fm_ServerConfig: Tfm_ServerConfig;

implementation

{$R *.dfm}

uses serverMainUnit;

procedure Tfm_ServerConfig.bt_okClick(Sender: TObject);
// ==========================================================================//
// ݒ@OK
// ==========================================================================//
var
  SL: TstringList;
begin
  serverMainUnit.ServerClass.sc_dataFileName := Edit_dataFileName.Text;
  serverMainUnit.ServerClass.sc_backupFileName := Edit_backupFileName.Text;
  serverMainUnit.ServerClass.sc_backupIntervalTime :=
    StrToInt(Edit_backupIntervalTime.Text);
  serverMainUnit.ServerClass.sc_dataPreservationDays :=
    StrToInt(Edit_dataPreservationDays.Text);
  serverMainUnit.ServerClass.sc_backupPreservationDays :=
    StrToInt(Edit_backupPreservationDays.Text);

  SL := TstringList.create;
  SL.Delimiter := #9;
  SL.Text := mm_groupName.Text;
  serverMainUnit.ServerClass.sc_groupName := SL.DelimitedText;

  serverMainUnit.ServerClass.sc_pcNameCheck := Edit_pcNameCheck.ItemIndex;
  serverMainUnit.ServerClass.sc_macAddrCheck := Edit_macAddrCheck.ItemIndex;
  serverMainUnit.ServerClass.sc_logDeleteDays :=
    StrToInt(Edit_logDaleteDays.Text);
  serverMainUnit.ServerClass.sc_pcCheckFileName := Edit_pcNameCheckFile.Text;
  serverMainUnit.ServerClass.sc_macAddrCheckFileName :=
    Edit_macAddrCheckFile.Text;
  serverMainUnit.ServerClass.sc_logFileName := Edit_logFileName.Text;
  serverMainUnit.ServerClass.sc_port := StrToInt(Edit_port.Text);
  ServerClass.sc_logDeleteDays := StrToInt(Edit_logDaleteDays.Text);

  ServerContainer1.DSHTTPService1.HttpPort :=
    serverMainUnit.ServerClass.sc_port;
  ServerContainer1.DSHTTPService1.Stop;
  ServerContainer1.DSHTTPService1.Start;

  if ServerContainer1.DSHTTPService1.Active then
    ServerClass.unyolog2('server restart OK')
  else
    ServerClass.unyolog2('server restart NG');

  ServerClass.iniFileWrite;
  ServerClass.unyolog2('config update');

  fm_ServerConfig.Close;

end;

function GetStartupFolder: string;
var Path: array [0 .. MAX_PATH] of Char; pidl: PItemIDList;
begin
  SHGetSpecialFolderLocation(Application.Handle, CSIDL_STARTUP, pidl);
  SHGetPathFromIDList(pidl, Path);
  Result := Path;
end;

function GetFolderName: string;
begin
  Result := ExtractFilePath(ParamStr(0));
end;

function GetExeName: string;
begin
  Result := StringReplace(ParamStr(0), ExtractFilePath(ParamStr(0)), '', [rfReplaceAll]);
end;

function CreateShortCut(ShortcutPath, ExecFilePath, SavePath: string): boolean;
var SL: IShelllink; PF: IPersistFile; wFileName: WideString;
begin
  Result := false;
  SL := CreateComObject(CLSID_ShellLink) as IShelllink;
  PF := SL as IPersistFile;
  if SL.SetPath(PChar(ExecFilePath)) <> NOERROR then Abort;
  if SL.SetWorkingDirectory(PChar(ExtractFilePath(ExecFilePath))) <> NOERROR then Abort;
  wFileName := SavePath + '\' + ChangeFileExt(ExtractFileName(ShortcutPath), '') + '.lnk';
  if PF.Save(PWChar(wFileName), false) <> NOERROR then Abort;
  Result := true;
end;

procedure Tfm_ServerConfig.bt_startupClick(Sender: TObject);
// ==========================================================================//
// X^[gAbvo^
// ==========================================================================//
var ShortcutPath: string;
begin
  ShortcutPath := GetExeName;
  if CreateShortCut(ShortcutPath, GetFolderName + GetExeName, GetStartupFolder) then begin
    showmessage('o^');
  end
  else showmessage('o^s');

end;


procedure Tfm_ServerConfig.bt_cancelClick(Sender: TObject);
// ==========================================================================//
// ݒ@CANCEL
// ==========================================================================//
var
  SL: TstringList;
begin
  Edit_dataFileName.Text := serverMainUnit.ServerClass.sc_dataFileName;
  Edit_backupFileName.Text := serverMainUnit.ServerClass.sc_backupFileName;
  Edit_dataPreservationDays.Text :=
    inttostr(serverMainUnit.ServerClass.sc_backupPreservationDays);
  Edit_backupPreservationDays.Text :=
    inttostr(serverMainUnit.ServerClass.sc_dataPreservationDays);
  Edit_backupIntervalTime.Text :=
    inttostr(serverMainUnit.ServerClass.sc_backupIntervalTime);

  SL := TstringList.create;
  SL.Delimiter := #9;
  SL.DelimitedText := serverMainUnit.ServerClass.sc_groupName;
  mm_groupName.Text := SL.Text;

  Edit_pcNameCheck.ItemIndex := serverMainUnit.ServerClass.sc_pcNameCheck;
  Edit_macAddrCheck.ItemIndex := serverMainUnit.ServerClass.sc_macAddrCheck;
  Edit_logDaleteDays.Text :=
    inttostr(serverMainUnit.ServerClass.sc_logDeleteDays);
  Edit_pcNameCheckFile.Text := serverMainUnit.ServerClass.sc_pcCheckFileName;
  Edit_macAddrCheckFile.Text :=
    serverMainUnit.ServerClass.sc_macAddrCheckFileName;
  Edit_logFileName.Text := serverMainUnit.ServerClass.sc_logFileName;
  fm_ServerConfig.Close;
  Edit_port.Text := inttostr(serverMainUnit.ServerClass.sc_port);
end;

procedure Tfm_ServerConfig.FormCreate(Sender: TObject);
// ==========================================================================//
// ݒ@tH[
// ==========================================================================//
var
  SL: TstringList;
begin
  Edit_dataFileName.Text := serverMainUnit.ServerClass.sc_dataFileName;
  Edit_backupFileName.Text := serverMainUnit.ServerClass.sc_backupFileName;
  Edit_dataPreservationDays.Text :=
    inttostr(serverMainUnit.ServerClass.sc_dataPreservationDays);
  Edit_backupPreservationDays.Text :=
    inttostr(serverMainUnit.ServerClass.sc_backupPreservationDays);
  Edit_backupIntervalTime.Text :=
    inttostr(serverMainUnit.ServerClass.sc_backupIntervalTime);

  SL := TstringList.create;
  SL.Delimiter := #9;
  SL.DelimitedText := serverMainUnit.ServerClass.sc_groupName;
  mm_groupName.Text := SL.Text;

  Edit_pcNameCheck.ItemIndex := serverMainUnit.ServerClass.sc_pcNameCheck;
  Edit_macAddrCheck.ItemIndex := serverMainUnit.ServerClass.sc_macAddrCheck;
  Edit_logDaleteDays.Text :=
    inttostr(serverMainUnit.ServerClass.sc_logDeleteDays);
  Edit_pcNameCheckFile.Text := serverMainUnit.ServerClass.sc_pcCheckFileName;
  Edit_macAddrCheckFile.Text :=
    serverMainUnit.ServerClass.sc_macAddrCheckFileName;
  Edit_logFileName.Text := serverMainUnit.ServerClass.sc_logFileName;
  Edit_port.Text := inttostr(serverMainUnit.ServerClass.sc_port);

end;

end.
