// 
unit ServerMainUnit;

interface

uses Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  Vcl.StdCtrls, serverMsgListUnit, Vcl.ExtCtrls,
  serverClassUnit, serverConfigUnit, serverMsgSendUnit, Vcl.Menus,
  ShellAPI, pngimage, Data.DBXDataSnap, IPPeerClient, Data.DBXCommon,
  Data.DbxHTTPLayer, Data.DB, Data.SqlExpr;

type
  TMainForm = class(TForm)
    Timer1: TTimer;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    Timer2: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure sch;
    procedure Timer1Timer(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Timer2Timer(Sender: TObject);
  private
    procedure CreateTaskBarIcon;
    procedure DeleteTaskBarIcon;
    procedure TaskTrayWndProc(var Msg: TMessage);
    procedure UpdateTaskBarIcon;
    procedure WMQueryEndSession(var Msg: TWMQueryEndSession);
      message WM_QUERYENDSESSION;
  public
  end;

var
  MainForm: TMainForm;
  ServerClass: TServerClass;

  hWndTrayIcon: Longint; //
  uTaskBarRecreate: Longint; //
  FQueryEndSession: Boolean; //

implementation

{$R *.dfm}

Const
  WM_MY_TRAYICON = WM_USER + 100;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
// ==========================================================================//
// tH[N[Y
// ==========================================================================//
begin
  if FQueryEndSession then
    begin
      FQueryEndSession := false;
      DeleteTaskBarIcon;
      DeallocateHWnd(hWndTrayIcon);
      ServerClass.unyolog2('<Windows shutdown>');
      close;
    end
  else
    begin
      DeleteTaskBarIcon;
      DeallocateHWnd(hWndTrayIcon);
      ServerClass.unyolog2('<MintServer end>');
    end;

end;

procedure TMainForm.FormCreate(Sender: TObject);
// ==========================================================================//
// ʕ\
// ==========================================================================//
var
  temp: Tstringlist;
begin

  Top := 30; // tH[ʂ̏c̒ɕ\܂
  Left := (Screen.Width - Width) - 30; // tH[ʂ̉̒ɕ\܂

  ServerClass := TServerClass.Create;
  ServerClass.iniFileRead;
  ServerClass.iniFileWrite;
  sch;

  uTaskBarRecreate := RegisterWindowMessage('TaskbarCreated');
  hWndTrayIcon := AllocateHWnd(TaskTrayWndProc);
  CreateTaskBarIcon;
  ShowWindow(Application.Handle, SW_HIDE);
  Application.ShowMainForm := false;

  ServerClass.unyolog2('<MintServer start>');

  ServerClass.backup; // obNAbv
  ServerClass.unyolog2('Backup');

  // temp := Tstringlist.Create;
  // temp := ServerClass.getCheckMsgList(now - 2, '');
  // ShowMessage(IntToStr(temp.Count));
  // temp := ServerClass.getCheckMsgList(now - 2, 'y');
  // ShowMessage(IntToStr(temp.Count));

end;

procedure TMainForm.N1Click(Sender: TObject);
// ==========================================================================//
// \
// ==========================================================================//
begin
  if fm_msgList.Showing then
    fm_msgList.close
  else
    begin
      fm_msgList.Top := (Screen.Height div 2);
      fm_msgList.Left := (Screen.Width - fm_msgList.Width) - 30;
      fm_msgList.Height := (Screen.Height div 2) - 70;
      fm_msgList.show;
    end;
end;

procedure TMainForm.N2Click(Sender: TObject);
// ==========================================================================//
// bZ[WM
// ==========================================================================//
begin
  if serverMsgSendUnit.fm_sendMsg.Showing then
    serverMsgSendUnit.fm_sendMsg.close
  else
    begin
      serverMsgSendUnit.fm_sendMsg.Top := 30;
      serverMsgSendUnit.fm_sendMsg.Left :=
        (Screen.Width - serverMsgSendUnit.fm_sendMsg.Width) - 30;
      serverMsgSendUnit.fm_sendMsg.show;
    end;
end;

procedure TMainForm.N3Click(Sender: TObject);
// ==========================================================================//
// O\
// ==========================================================================//
var
  cmd: PAnsiChar;
  str: string;
begin
  str := 'Notepad.exe ' + ServerClass.sc_logFileName;
  GetMem(cmd, length(str) + 1);
  StrPCopy(cmd, str);
  WinExec(cmd, SW_SHOW);
end;

procedure TMainForm.N4Click(Sender: TObject);
// ==========================================================================//
// ݒ
// ==========================================================================//
begin
  if serverConfigUnit.fm_ServerConfig.Showing then
    serverConfigUnit.fm_ServerConfig.close
  else
    begin
      serverConfigUnit.fm_ServerConfig.Top := 30;
      serverConfigUnit.fm_ServerConfig.Left := 30;
      serverConfigUnit.fm_ServerConfig.show;
    end;
end;

procedure TMainForm.N5Click(Sender: TObject);
// ==========================================================================//
// I
// ==========================================================================//
begin
  close;
end;

procedure TMainForm.sch;
// ==========================================================================//
// XPW[[@obNAbvIɎs
// ==========================================================================//
var
  intervalTime: integer;
begin
  intervalTime := ServerClass.sc_backupIntervalTime * 3600000;
  Timer1.Interval := intervalTime;
  Timer1.Enabled := True;
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
// ==========================================================================//
// ^C}[@@obNAbv̋N
// ==========================================================================//
begin
  ServerClass.backup;
  ServerClass.unyolog2('Backup Timer Run');
end;

procedure TMainForm.Timer2Timer(Sender: TObject);
// ==========================================================================//
// gpPCXg̐
// ==========================================================================//
var
  I: integer;
  SL1, SL2: Tstringlist;
  time1, time2: TDateTime;
begin
  SL1 := Tstringlist.Create;
  SL2 := Tstringlist.Create;
  for I := 0 to ServerClass.activePcList.Count - 1 do
    begin
      SL1.Text := ServerClass.activePcList.Values[ServerClass.activePcList.Names[I]];
      time1 := StrToDateTime(SL1.Values['dateTime']);
      time2 := Now - StrToTime('0:01:00');
      if time1 < time2 then
        begin
          ServerClass.unyolog(SL1.Values['hostName'], SL1.Values['macAddr'],
            SL1.Values['ipAddr'], SL1.Values['sender'] + ' Connection End');
        end
      else
        begin
          SL2.add(ServerClass.activePcList.Strings[I]);
        end;
    end;
  ServerClass.activePcList := SL2;
end;

procedure TMainForm.CreateTaskBarIcon;
// ==========================================================================//
// ACRgCɓo^
// ==========================================================================//
var
  NotifyData: TNotifyIconData;
  rc: Boolean;
  SL: Tstringlist;
  I: integer;
  str: string;

begin
  with NotifyData do
    begin
      // cbSize := SizeOf(TNotifyIconData);
      cbSize := 100;
      Wnd := hWndTrayIcon;
      uID := 0;
      uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;

      SL := Tstringlist.Create;
      SL.Delimiter := '\';
      SL.DelimitedText := ExtractFilePath(Application.ExeName);
      I := SL.Count - 2;
      str := 'mint ' + SL.Strings[I];
      StrCopy(szTip, PChar(str));
      SL.Free;

      hIcon := Application.Icon.Handle;
      uCallbackMessage := WM_MY_TRAYICON;
    end;
  rc := Shell_NotifyIcon(NIM_ADD, @NotifyData);
  if rc then
  else
    begin
      sleep(5000);
      CreateTaskBarIcon;
    end;
end;

procedure TMainForm.DeleteTaskBarIcon;
// ==========================================================================//
// ACR폜
// ==========================================================================//
var
  NotifyData: TNotifyIconData;
begin
  with NotifyData do
    begin
      // cbSize := SizeOf(TNotifyIconData);
      cbSize := 100;
      Wnd := hWndTrayIcon;
      uID := 0;
    end;
  Shell_NotifyIcon(NIM_DELETE, @NotifyData);
end;

procedure TMainForm.TaskTrayWndProc(var Msg: TMessage);
// ==========================================================================//
// ^XNgCɗ郁bZ[WM
// ==========================================================================//
var
  ps: TPoint;
begin
  Case Msg.lParam of
    WM_LBUTTONDBLCLK:
      // _uNbN@ݒʕ\
      begin
        N1Click(Self);
      end;
    WM_LBUTTONUP:
      // NbN@popup menu \
      begin
        GetCursorPos(ps);
        SetForegroundWindow(Handle);
        PopupMenu1.Popup(ps.x, ps.y);
        PostMessage(Handle, WM_NULL, 0, 0);
      end;
    WM_RBUTTONUP:
      // ENbN@popup menu \
      begin
        GetCursorPos(ps);
        SetForegroundWindow(Handle);
        PopupMenu1.Popup(ps.x, ps.y);
        PostMessage(Handle, WM_NULL, 0, 0);
      end;
  else
    // ^XNo[ړEč\zꂽꍇɏACRĐ
    if (Msg.lParam = Longint(uTaskBarRecreate)) then
      CreateTaskBarIcon;
  end;
end;

procedure TMainForm.UpdateTaskBarIcon;
// ==========================================================================//
// ^XNgC̃ACRύX
// ==========================================================================//
var
  NotifyData: TNotifyIconData;
  SL: Tstringlist;
  I: integer;
  str: string;

begin
  with NotifyData do
    begin
      // cbSize := SizeOf(TNotifyIconData);
      cbSize := 100;
      Wnd := hWndTrayIcon;
      uID := 0;
      uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;

      SL := Tstringlist.Create;
      SL.Delimiter := '\';
      SL.DelimitedText := ExtractFilePath(Application.ExeName);
      I := SL.Count - 2;
      str := 'mint ' + SL.Strings[I];
      StrCopy(szTip, PChar(str));
      szTip := 'mint';
      SL.Free;

      hIcon := Application.Icon.Handle;
      uCallbackMessage := WM_MY_TRAYICON;
    end;
  Shell_NotifyIcon(NIM_MODIFY, @NotifyData);
end;

procedure TMainForm.WMQueryEndSession(var Msg: TWMQueryEndSession);
// ==========================================================================//
// Vbg_ECxg
// ==========================================================================//
begin
  FQueryEndSession := True;
  inherited;
end;

end.
