// 
unit ServerMsgListUnit;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.Grids,
  ServerClassUnit, StrUtils, ServerMsgDisplay,
  dxAlertWindow, cxGraphics, cxLookAndFeelPainters, Vcl.Menus, Clipbrd,
  Vcl.ImgList;

type
  Tfm_msgList = class(TForm)
    StringGrid1: TStringGrid;
    bt_update: TButton;
    lb_msgCount: TLabel;
    Panel1: TPanel;
    lb_connctCnt: TLabel;
    bt_ActList: TButton;
    dxAlertWindowManager1: TdxAlertWindowManager;
    PopupMenu2: TPopupMenu;
    N5: TMenuItem;
    cxImageList1: TcxImageList;
    procedure FormCreate(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure StringGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bt_updateClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure StringGrid1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure bt_ActListClick(Sender: TObject);
     function GetCurrentMessage(AAlertWindow: TdxAlertWindow)
      : TdxAlertWindowMessage;
  private
  public
  end;

var
  fm_msgList: Tfm_msgList;
  ServerClass: TServerClass;
  SL, ML: TStringList; // SL IWiXg@ML@\pXg

implementation

uses ServerMainUnit;
{$R *.dfm}

procedure Tfm_msgList.bt_ActListClick(Sender: TObject);
// ==========================================================================//
// ڑꗗ
// ==========================================================================//
var
  i: Integer;
  SL: TStringList;
  msg: String;
begin
  if ServerMainUnit.ServerClass.activePcList.count = 0 then
    ShowMessage('ڑĂ闘p҂͂܂B')
  else
    begin
      msg := 'ڑꗗ' + #13#10;
      SL := TStringList.create;
      for i := 0 to ServerMainUnit.ServerClass.activePcList.count - 1 do
        begin
          SL.Text := ServerMainUnit.ServerClass.activePcList.Values
            [ServerMainUnit.ServerClass.activePcList.Names[i]];
          msg := msg + SL.Values['hostName'] + ' ' + SL.Values
            ['sender'] + #13#10;
        end;
      ShowMessage(msg);
    end;
end;

procedure Tfm_msgList.FormCreate(Sender: TObject);
// ==========================================================================//
// tH[
// ==========================================================================//
var
  i: Integer;
begin
  StringGrid1.RowCount := 0;
  StringGrid1.refresh;
  StringGrid1.ColWidths[0] := 500;
  StringGrid1.DefaultDrawing := FALSE;
  StringGrid1.DefaultRowHeight := 56;
  StringGrid1.ColCount := 1;
  StringGrid1.ScrollBars := ssVertical;

  SL := ServerMainUnit.ServerClass.getFullMsgList(True);
  ML := ServerMainUnit.ServerClass.MsgList(SL);
  StringGrid1.RowCount := SL.count;
  for i := 0 to ML.count - 1 do
    begin
      StringGrid1.Cells[0, i] := ML.Strings[i];
    end;
  lb_msgCount.Caption := IntToStr(StringGrid1.Row + 1) + '/' +
    IntToStr(StringGrid1.RowCount);
  lb_connctCnt.Caption := 'ڑF' +
    IntToStr(ServerMainUnit.ServerClass.activePcList.count);

end;

procedure Tfm_msgList.bt_updateClick(Sender: TObject);
// ==========================================================================//
// XV
// ==========================================================================//
var
  topRow, Row: Integer;
begin
  topRow := StringGrid1.topRow;
  Row := StringGrid1.Row;
  FormCreate(nil);
  if StringGrid1.RowCount >= topRow then
    StringGrid1.topRow := topRow
  else
    StringGrid1.topRow := StringGrid1.RowCount;

  if StringGrid1.RowCount > Row then
    StringGrid1.Row := Row
  else
    StringGrid1.Row := StringGrid1.RowCount - 1;
  StringGrid1.SetFocus;
end;

procedure Tfm_msgList.FormShow(Sender: TObject);
// ==========================================================================//
// bZ[WtH[\
// ==========================================================================//
begin
  FormCreate(nil);
end;

function Tfm_msgList.GetCurrentMessage(
  AAlertWindow: TdxAlertWindow): TdxAlertWindowMessage;
// ==========================================================================//
// fXNgbvʒmFNbv{[hւ̃Rs[p̃JgbZ[W̎擾
// ==========================================================================//
begin
  Result := AAlertWindow.MessageList[AAlertWindow.CurrentMessageIndex];
end;

procedure Tfm_msgList.StringGrid1DrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
// ==========================================================================//
// XgOObh@\
// ==========================================================================//
var
  s: array [0 .. 5000] of Char;
begin
  with StringGrid1.Canvas do
    begin
      Font := StringGrid1.Font;

      if gdFocused in State then
        begin
          Brush.Color := clSkyBlue;
          DrawFocusRect(Rect);
        end
      else
        begin
          Brush.Color := clWhite;
        end;

      FillRect(Rect);
      StrPCopy(s, StringGrid1.Cells[Col, Row]);
      DrawText(StringGrid1.Canvas.Handle, s, -1, Rect, DT_WORDBREAK);

      lb_msgCount.Caption := RightStr('0000' + IntToStr(StringGrid1.Row + 1), 4)
        + '/' + RightStr('0000' + IntToStr(StringGrid1.RowCount), 4);

    end;
end;

procedure Tfm_msgList.StringGrid1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
// ==========================================================================//
// L[_E
// ==========================================================================//
var
  strDt, strRandam: string;
  tempDT: TDateTime;
  tempRandam: Integer;
  topRow, Row: Integer;
begin
  if (Key = VK_DELETE) then
    begin
      strDt := ServerMainUnit.ServerClass.csvValue
        (SL.Strings[StringGrid1.Row], 1);
      strRandam := ServerMainUnit.ServerClass.csvValue
        (SL.Strings[StringGrid1.Row], 7);
      topRow := StringGrid1.topRow;
      Row := StringGrid1.Row;
      if MessageDlg('폜܂H', mtWarning, [mbYes, mbNo], 0) = mrYes then
        begin
          tempDT := StrToDateTime(strDt);
          tempRandam := strtoint(strRandam);
          if ServerMainUnit.ServerClass.DeleteMsg(tempDT, tempRandam) then
            begin
              FormCreate(nil);
              if StringGrid1.RowCount >= topRow then
                StringGrid1.topRow := topRow
              else
                StringGrid1.topRow := StringGrid1.RowCount;
              if StringGrid1.RowCount > Row then
                StringGrid1.Row := Row
              else
                StringGrid1.Row := StringGrid1.RowCount - 1;
            end;
        end;
    end;

  if (Key = VK_RETURN) then
    begin
           dxAlertWindowManager1.show('[' + serverClass.csvValue(SL.Strings[StringGrid1.Row],
            4) + '] ' + serverClass.csvValue(SL.Strings[StringGrid1.Row], 5) + '@' +
            serverClass.csvValue(SL.Strings[StringGrid1.Row], 1) + '@' +
            serverClass.csvValue(SL.Strings[StringGrid1.Row], 11),
            serverClass.TextToMemo(serverClass.csvValue(SL.Strings[StringGrid1.Row], 3)),
            strToInt(serverClass.csvValue(SL.Strings[StringGrid1.Row], 6)));
   end;
end;

procedure Tfm_msgList.StringGrid1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
// ==========================================================================//
// XgOObh@}EX_E
// ==========================================================================//
var
  strDt, strRandam: string;
  tempDT: TDateTime;
  tempRandam: Integer;
  topRow, Row: Integer;
begin
  if Button = mbRight then
    begin
      strDt := ServerMainUnit.ServerClass.csvValue
        (SL.Strings[StringGrid1.Row], 1);
      strRandam := ServerMainUnit.ServerClass.csvValue
        (SL.Strings[StringGrid1.Row], 7);
      topRow := StringGrid1.topRow;
      Row := StringGrid1.Row;
      if MessageDlg('폜܂H', mtWarning, [mbYes, mbNo], 0) = mrYes then
        begin
          tempDT := StrToDateTime(strDt);
          tempRandam := strtoint(strRandam);

          if ServerMainUnit.ServerClass.DeleteMsg(tempDT, tempRandam) then
            begin
              FormCreate(nil);
              if StringGrid1.RowCount >= topRow then
                StringGrid1.topRow := topRow
              else
                StringGrid1.topRow := StringGrid1.RowCount;
              if StringGrid1.RowCount > Row then
                StringGrid1.Row := Row
              else
                StringGrid1.Row := StringGrid1.RowCount - 1;
            end;
        end;
    end
  else
    begin
           dxAlertWindowManager1.show('[' + serverClass.csvValue(SL.Strings[StringGrid1.Row],
            4) + '] ' + serverClass.csvValue(SL.Strings[StringGrid1.Row], 5) + '@' +
            serverClass.csvValue(SL.Strings[StringGrid1.Row], 1) + '@' +
            serverClass.csvValue(SL.Strings[StringGrid1.Row], 11),
            serverClass.TextToMemo(serverClass.csvValue(SL.Strings[StringGrid1.Row], 3)),
            strToInt(serverClass.csvValue(SL.Strings[StringGrid1.Row], 6)));
    end;
end;

end.
