//
// DataSnap vLV WFl[^ɂ쐬B
// 2013/07/24 22:25:47
//

unit s03methods;

interface

uses Data.DBXCommon, Data.DBXClient, Data.DBXDataSnap, Data.DBXJSON,
  Datasnap.DSProxy, System.Classes, System.SysUtils, Data.DB, Data.SqlExpr,
  Data.DBXDBReaders, Data.DBXCDSReaders, Data.DBXJSONReflect;

type
  TServerMethods1Client = class(TDSAdminClient)
  private
    FpcCheckCommand: TDBXCommand;
    FcheckMessageCommand: TDBXCommand;
    FgetFullMessageCommand: TDBXCommand;
    FregistMessageCommand: TDBXCommand;
    FdeleteMessageCommand: TDBXCommand;
    FgetGroupNameCommand: TDBXCommand;
    FgetActivePcListCommand: TDBXCommand;
  public
    constructor Create(ADBXConnection: TDBXConnection); overload;
    constructor Create(ADBXConnection: TDBXConnection;
      AInstanceOwner: Boolean); overload;
    destructor Destroy; override;
    function pcCheck(pcName: string; macAddr: string; ipAddr: string): Integer;
    function checkMessage(lastDateTime: TDateTime; groupName: string;
      macAddr: string; ipAddr: string; hostName: string;
      sender: string): string;
    function getFullMessage: string;
    function registMessage(MSG: string): Boolean;
    function deleteMessage(dateTime: TDateTime; randam: Integer): Boolean;
    function getGroupName: string;
    function getActivePcList: string;
  end;

implementation

function TServerMethods1Client.pcCheck(pcName: string; macAddr: string;
  ipAddr: string): Integer;
begin
  if FpcCheckCommand = nil then
    begin
      FpcCheckCommand := FDBXConnection.CreateCommand;
      FpcCheckCommand.CommandType := TDBXCommandTypes.DSServerMethod;
      FpcCheckCommand.Text := 'TServerMethods1.pcCheck';
      FpcCheckCommand.Prepare;
    end;
  FpcCheckCommand.Parameters[0].Value.SetWideString(pcName);
  FpcCheckCommand.Parameters[1].Value.SetWideString(macAddr);
  FpcCheckCommand.Parameters[2].Value.SetWideString(ipAddr);
  FpcCheckCommand.ExecuteUpdate;
  Result := FpcCheckCommand.Parameters[3].Value.GetInt32;
end;

function TServerMethods1Client.checkMessage(lastDateTime: TDateTime;
  groupName: string; macAddr: string; ipAddr: string; hostName: string;
  sender: string): string;
begin
  if FcheckMessageCommand = nil then
    begin
      FcheckMessageCommand := FDBXConnection.CreateCommand;
      FcheckMessageCommand.CommandType := TDBXCommandTypes.DSServerMethod;
      FcheckMessageCommand.Text := 'TServerMethods1.checkMessage';
      FcheckMessageCommand.Prepare;
    end;
  FcheckMessageCommand.Parameters[0].Value.AsDateTime := lastDateTime;
  FcheckMessageCommand.Parameters[1].Value.SetWideString(groupName);
  FcheckMessageCommand.Parameters[2].Value.SetWideString(macAddr);
  FcheckMessageCommand.Parameters[3].Value.SetWideString(ipAddr);
  FcheckMessageCommand.Parameters[4].Value.SetWideString(hostName);
  FcheckMessageCommand.Parameters[5].Value.SetWideString(sender);
  FcheckMessageCommand.ExecuteUpdate;
  Result := FcheckMessageCommand.Parameters[6].Value.GetWideString;
end;

function TServerMethods1Client.getFullMessage: string;
begin
  if FgetFullMessageCommand = nil then
    begin
      FgetFullMessageCommand := FDBXConnection.CreateCommand;
      FgetFullMessageCommand.CommandType := TDBXCommandTypes.DSServerMethod;
      FgetFullMessageCommand.Text := 'TServerMethods1.getFullMessage';
      FgetFullMessageCommand.Prepare;
    end;
  FgetFullMessageCommand.ExecuteUpdate;
  Result := FgetFullMessageCommand.Parameters[0].Value.GetWideString;
end;

function TServerMethods1Client.registMessage(MSG: string): Boolean;
begin
  if FregistMessageCommand = nil then
    begin
      FregistMessageCommand := FDBXConnection.CreateCommand;
      FregistMessageCommand.CommandType := TDBXCommandTypes.DSServerMethod;
      FregistMessageCommand.Text := 'TServerMethods1.registMessage';
      FregistMessageCommand.Prepare;
    end;
  FregistMessageCommand.Parameters[0].Value.SetWideString(MSG);
  FregistMessageCommand.ExecuteUpdate;
  Result := FregistMessageCommand.Parameters[1].Value.GetBoolean;
end;

function TServerMethods1Client.deleteMessage(dateTime: TDateTime;
  randam: Integer): Boolean;
begin
  if FdeleteMessageCommand = nil then
    begin
      FdeleteMessageCommand := FDBXConnection.CreateCommand;
      FdeleteMessageCommand.CommandType := TDBXCommandTypes.DSServerMethod;
      FdeleteMessageCommand.Text := 'TServerMethods1.deleteMessage';
      FdeleteMessageCommand.Prepare;
    end;
  FdeleteMessageCommand.Parameters[0].Value.AsDateTime := dateTime;
  FdeleteMessageCommand.Parameters[1].Value.SetInt32(randam);
  FdeleteMessageCommand.ExecuteUpdate;
  Result := FdeleteMessageCommand.Parameters[2].Value.GetBoolean;
end;

function TServerMethods1Client.getGroupName: string;
begin
  if FgetGroupNameCommand = nil then
    begin
      FgetGroupNameCommand := FDBXConnection.CreateCommand;
      FgetGroupNameCommand.CommandType := TDBXCommandTypes.DSServerMethod;
      FgetGroupNameCommand.Text := 'TServerMethods1.getGroupName';
      FgetGroupNameCommand.Prepare;
    end;
  FgetGroupNameCommand.ExecuteUpdate;
  Result := FgetGroupNameCommand.Parameters[0].Value.GetWideString;
end;

function TServerMethods1Client.getActivePcList: string;
begin
  if FgetActivePcListCommand = nil then
    begin
      FgetActivePcListCommand := FDBXConnection.CreateCommand;
      FgetActivePcListCommand.CommandType := TDBXCommandTypes.DSServerMethod;
      FgetActivePcListCommand.Text := 'TServerMethods1.getActivePcList';
      FgetActivePcListCommand.Prepare;
    end;
  FgetActivePcListCommand.ExecuteUpdate;
  Result := FgetActivePcListCommand.Parameters[0].Value.GetWideString;
end;

constructor TServerMethods1Client.Create(ADBXConnection: TDBXConnection);
begin
  inherited Create(ADBXConnection);
end;

constructor TServerMethods1Client.Create(ADBXConnection: TDBXConnection;
  AInstanceOwner: Boolean);
begin
  inherited Create(ADBXConnection, AInstanceOwner);
end;

destructor TServerMethods1Client.Destroy;
begin
  FreeAndNil(FpcCheckCommand);
  FreeAndNil(FcheckMessageCommand);
  FreeAndNil(FgetFullMessageCommand);
  FreeAndNil(FregistMessageCommand);
  FreeAndNil(FdeleteMessageCommand);
  FreeAndNil(FgetGroupNameCommand);
  FreeAndNil(FgetActivePcListCommand);
  inherited;
end;

end.
