// 
unit u02ClientLogic;

interface

uses Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, IniFiles,
  Winsock, IdUDPClient, IdStack, StrUtils, DBXCompressionFilter,
  u07ClientDataSnap;

type

  TClientLogic = class
    cc_HostName: string; // zXg
    cc_Port: integer; // |[gԍ
    cc_CheckInterval: integer; // `FbNԊuibj
    cc_GroupName: string; // O[v
    cc_Keyword: string; // L[[h
    cc_LogFileName: string; // Ot@C
    cc_LogDeleteDays: integer; // Oۑ
    cc_sender: string; // M
    cc_LastHostName: string; // ŌɐڑzXg
    cc_LastPort: integer; // Ōɐڑ|[gԍ
    ClientStatus: boolean; // NCAg
    lastDateTime: TDateTime; // Ō̃`FbN
    networkError: boolean; // lbg[NG[

  private
  public
    procedure iniFileRead; // T[oinit@C̓ǂݍ
    procedure iniFileWrite; // T[oinit@C̏o
    function backup(): boolean; // obNAbv
    function csvValue(str: string; n: integer): string; // csveLXg̒lo
    function DeleteMsg(dateTime: TDateTime; randam: integer): boolean;
    // bZ[W폜
    function getCheckMsgList(dateTime: TDateTime; groupName: string;
      macAddr: String; ipAddr: string; hostName: string; sender: string)
      : TStringList; // bZ[W̓o
    function getFullMsgList(): TStringList; // SbZ[W̎擾
    function getFullMsgList2(groupName: string): TStringList; // SbZ[W̎擾
    function GetHostName(): string; // zXgiPCj̎擾
    function GetIpAdress(): string; // IPAhX̎擾
    function GetMACAdress(IPAddress: string): string; // MACAhX̎擾
    // function MessageList(): TStringList; // bZ[Wꗗ
    function MsgList(var SL: TStringList): TStringList; // bZ[Wꗗi~j
    function MsgList2(var SL: TStringList): TStringList; // bZ[Wꗗij
    function pcCheck(pcName: string; macAddr: string; ipAddr: string): integer;
    // PC
    function registMessage(MSG: TStringList): boolean; // bZ[Wo^
    function unyolog(pcName: string; macAddr: string; ipAddr: string;
      MSG: string): boolean; // Oo
    function unyolog2(MSG: string): boolean; // Oo
    function getGroupName(): string;
    function getActivePcList(): string;
    function MemoToText(aMemo: string): string;
    function TextToMemo(aText: string): string;
    function getServerTime(): string;


  end;

implementation

uses u01ClientMain;

procedure TClientLogic.iniFileRead;
// ==========================================================================//
// ini file ǂݍ
// ==========================================================================//
var
  Ini: TIniFile;
begin
  Ini := TIniFile.create(ChangeFileExt(Application.ExeName, '.ini'));
  try
    cc_HostName := Ini.ReadString('mintClient', 'HostName', 'localhost');
    cc_LastHostName := Ini.ReadString('mintClient', 'LastHostName',
      'localhost');
    cc_Port := Ini.ReadInteger('mintClient', 'Port', 8070);
    cc_LastPort := Ini.ReadInteger('mintClient', 'LastPort', 8070);
    cc_CheckInterval := Ini.ReadInteger('mintClient', 'CheckInterval', 30);
    cc_GroupName := Ini.ReadString('mintClient', 'GroupName', '');
    cc_Keyword := Ini.ReadString('mintClient', 'Keyword', '');
    cc_LogFileName := Ini.ReadString('mintClient', 'LogFileName',
      'mint_logFile.txt');
    cc_LogDeleteDays := Ini.ReadInteger('mintClient', 'LogDeleteDays', 30);
    cc_sender := Ini.ReadString('mintClient', 'sender', '');
  finally
    Ini.Free
  end;
end;

procedure TClientLogic.iniFileWrite;
// ==========================================================================//
// ini file 
// ==========================================================================//
var
  Ini: TIniFile;
begin
  Ini := TIniFile.create(ChangeFileExt(Application.ExeName, '.ini'));
  try
    Ini.WriteString('mintClient', 'HostName', cc_HostName);
    Ini.WriteInteger('mintClient', 'Port', cc_Port);
    Ini.WriteString('mintClient', 'LastHostName', cc_LastHostName);
    Ini.WriteInteger('mintClient', 'LastPort', cc_LastPort);
    Ini.WriteInteger('mintClient', 'CheckInterval', cc_CheckInterval);
    Ini.WriteString('mintClient', 'GroupName', cc_GroupName);
    Ini.WriteString('mintClient', 'Keyword', cc_Keyword);
    Ini.WriteString('mintClient', 'logFileName', cc_LogFileName);
    Ini.WriteInteger('mintClient', 'LogDeleteDays', cc_LogDeleteDays);
    Ini.WriteString('mintClient', 'sender', cc_sender);
  finally
    Ini.Free
  end;
end;

function TClientLogic.MemoToText(aMemo: string): string;
// ==========================================================================//
// s̕ϊ
// ==========================================================================//
const
  NewLine = #13#10;
  EncCode = #12;
var
  aBuff: string;
  cnt: integer;
begin
  result := '';
  aBuff := TrimRight(AdjustLineBreaks(aMemo));
  for cnt := 1 to length(aBuff) do
    begin
      if IsDelimiter(NewLine, aBuff, cnt) then
        begin
          if Copy(aBuff, cnt, 1) = #13 then
            result := result + EncCode;
        end
      else
        begin
          result := result + Copy(aBuff, cnt, 1);
        end;
    end;
end;

function TClientLogic.TextToMemo(aText: string): string;
// ==========================================================================//
// s̖߂
// ==========================================================================//
const
  NewLine = #13#10;
  EncCode = #12;
var
  aBuff: string;
  cnt: integer;
begin
  aBuff := '';
  for cnt := 1 to length(aText) do
    begin
      if IsDelimiter(EncCode, aText, cnt) then
        aBuff := aBuff + NewLine
      else
        aBuff := aBuff + Copy(aText, cnt, 1);
    end;
  result := aBuff;
end;

function TClientLogic.registMessage(MSG: TStringList): boolean;
// ==========================================================================//
// bZ[W̏
// ==========================================================================//
var
  DataSnap: TServerMethods1Client;
begin
  try
    u01ClientMain.fm_Main.SQLConnection1.Open;
    DataSnap := u07ClientDataSnap.TServerMethods1Client.create
      (u01ClientMain.fm_Main.SQLConnection1.DBXConnection);
    result := DataSnap.registMessage(MSG.Text);
    DataSnap.Free;
  except
  end;
end;

function TClientLogic.unyolog(pcName, macAddr, ipAddr, MSG: string): boolean;
// ==========================================================================//
// Oo
// ==========================================================================//
var
  DF: TextFile;
  SL: TStringList;
  buf: string;

begin
  result := false;

  if FileExists(cc_LogFileName) then
  else
    begin
      AssignFile(DF, cc_LogFileName);
      Rewrite(DF);
      CloseFile(DF);
    end;

  try
    AssignFile(DF, cc_LogFileName);
    SL := TStringList.create;
    Append(DF);
    SL.Delimiter := #9; // TAB
    SL.StrictDelimiter := true;
    SL.Clear;
    SL.Add(FormatDateTime('yyyy/mm/dd hh:mm:ss',now)); // 1
    SL.Add(pcName); // 2
    SL.Add(ipAddr); // 3
    SL.Add(macAddr); // 4
    SL.Add(MemoToText(MSG)); // 5
    buf := SL.DelimitedText;
    buf := AnsiReplaceStr(buf, '"', '');
    WriteLn(DF, buf);
    CloseFile(DF);
    result := true;
    SL.Free;
  except
  end;

end;

function TClientLogic.unyolog2(MSG: string): boolean;
// ==========================================================================//
// Oó@p
// ==========================================================================//
begin
  unyolog(GetHostName, GetMACAdress(GetIpAdress), GetIpAdress, MSG);
end;

function CustomSortASC(List: TStringList; Index1, Index2: integer): integer;
// ==========================================================================//
// JX^\[g  \[g
// ==========================================================================//
begin
  // result := AnsiCompareStr(List[Index1], List[Index2]); // P[l/啶
  result := CompareStr(List[Index1], List[Index2]);
  // P[/啶
  // result := AnsiCompareText(List[Index1], List[Index2]); // P[l/啶
  // result := CompareText(List[Index1], List[Index2]); // P[/啶
end;

function CustomSortDESC(List: TStringList; Index1, Index2: integer): integer;
// ==========================================================================//
// JX^\[g  ~\[g
// ==========================================================================//
begin
  // result := -AnsiCompareStr(List[Index1], List[Index2]); // P[l/啶
  result := -CompareStr(List[Index1], List[Index2]);
  // P[/啶
  // result := -AnsiCompareText(List[Index1], List[Index2]); // P[l/啶
  // result := -CompareText(List[Index1], List[Index2]); // P[/啶
end;

function TClientLogic.getFullMsgList(): TStringList;
// ==========================================================================//
// SbZ[W擾
// ==========================================================================//
var
  DataSnap: TServerMethods1Client;
  SL: TStringList;
begin
  try
    SL := TStringList.create;
    DataSnap := u07ClientDataSnap.TServerMethods1Client.create
      (fm_Main.SQLConnection1.DBXConnection);
    SL.Text := DataSnap.getFullMessage;
    result := SL;
    // SL.Free;
    DataSnap.Free;
  except
  end;
end;

function TClientLogic.getFullMsgList2(groupName: string): TStringList;
// ==========================================================================//
// SbZ[W擾 iO[voj
// ==========================================================================//
var
  DataSnap: TServerMethods1Client;
  SL1, SL2: TStringList;
  I: integer;
begin
  try
    SL1 := TStringList.create;
    SL2 := TStringList.create;
    DataSnap := u07ClientDataSnap.TServerMethods1Client.create
      (fm_Main.SQLConnection1.DBXConnection);
    SL1.Text := DataSnap.getFullMessage;

    if (groupName = '') or (groupName = 'SO[v') then
      result := SL1
    else
      begin
        for I := 0 to SL1.count - 1 do
          begin
            if (csvValue(SL1.Strings[I], 4) = groupName) or
              (csvValue(SL1.Strings[I], 4) = 'SO[v') or
              (csvValue(SL1.Strings[I], 4) = '') then
              SL2.Add(SL1.Strings[I]);
          end;
        result := SL2;
      end;

    // SL1.free;
    // SL2.free;
    DataSnap.Free;
  except
  end;
end;

function TClientLogic.getGroupName: string;
// ==========================================================================//
// O[v̎擾
// ==========================================================================//
var
  DataSnap: TServerMethods1Client;
begin
  try
    DataSnap := u07ClientDataSnap.TServerMethods1Client.create
      (fm_Main.SQLConnection1.DBXConnection);
    result := DataSnap.getGroupName();
    DataSnap.Free;
  except
  end;
end;

function TClientLogic.DeleteMsg(dateTime: TDateTime; randam: integer): boolean;
// ==========================================================================//
// bZ[W폜
// ==========================================================================//
var
  DataSnap: TServerMethods1Client;
begin
  try
    DataSnap := u07ClientDataSnap.TServerMethods1Client.create
      (fm_Main.SQLConnection1.DBXConnection);
    result := DataSnap.deleteMessage(dateTime, randam);
    DataSnap.Free;
  except
  end;
end;

function TClientLogic.getActivePcList: string;
// ==========================================================================//
// gpPCXg擾
// ==========================================================================//
var
  DataSnap: TServerMethods1Client;
begin
  try
    DataSnap := u07ClientDataSnap.TServerMethods1Client.create
      (fm_Main.SQLConnection1.DBXConnection);
    result := DataSnap.getActivePcList();
    DataSnap.Free;
  except
  end;
end;

function TClientLogic.getCheckMsgList(dateTime: TDateTime; groupName: string;
  macAddr: String; ipAddr: string; hostName: string; sender: string)
  : TStringList;
// ==========================================================================//
// bZ[W̓o
// ==========================================================================//
var
  DataSnap: TServerMethods1Client;
  SL: TStringList;
begin
  SL := TStringList.create;
  try
    u01ClientMain.fm_Main.SQLConnection1.Open;
    DataSnap := u07ClientDataSnap.TServerMethods1Client.create
      (fm_Main.SQLConnection1.DBXConnection);
    SL.Text := DataSnap.checkMessage(dateTime, groupName, macAddr, ipAddr,
      hostName, sender);
    result := SL;
    // SL.Free
    DataSnap.Free;
  except
  end;
end;

function TClientLogic.MsgList(var SL: TStringList): TStringList;
// ==========================================================================//
// bZ[WXg쐬  ͋t@i͂SLtɃ\[gj
// ==========================================================================//
var
  ML: TStringList;
  I: integer;
  buf: string;
begin
  try
    ML := TStringList.create;
    SL.CustomSort(CustomSortDESC); // ~\[g
    for I := 0 to SL.count - 1 do
      begin
        buf := SL.Strings[I];
        ML.Add('' + csvValue(buf, 1) + ' [' + csvValue(buf, 4) + '/' +
          csvValue(buf, 5) + '] ' + ' MҁF' + csvValue(buf, 11) + #13#10#9 +
          TextToMemo(csvValue(buf, 3)));
      end;
    result := ML;
    // ML.Free;
  except
  end;

end;

function TClientLogic.MsgList2(var SL: TStringList): TStringList;
// ==========================================================================//
// bZ[WXg쐬  ͏@i͂SLɃ\[gj
// ==========================================================================//
var
  ML: TStringList;
  I: integer;
  buf: string;
begin
  try
    ML := TStringList.create;
    SL.Sort; // \[g
    for I := 0 to SL.count - 1 do
      begin
        buf := SL.Strings[I];
        ML.Add('' + csvValue(buf, 1) + ' [' + csvValue(buf, 4) + '/' +
          csvValue(buf, 5) + '] ' + ' MҁF' + csvValue(buf, 11) + #13#10#9 +
          TextToMemo(csvValue(buf, 3)));
      end;
    result := ML;
    // ML.Free;
  except
  end;

end;

function TClientLogic.pcCheck(pcName, macAddr, ipAddr: string): integer;
// ==========================================================================//
// PC
// ==========================================================================//
// sc_pcCheckFileName
// sc_macAddrCheckFileName
// sc_pcNameCheck
// sc_macAddrCheck

// error flag
// 1 pcname no check
// 2 macaddr no check
// 4 pcname error
// 8 macaddr error
//
// 0@OK
// 1@pcname no check
// 2  macaddr no check
// 3  pcname,macaddr no check
// -----------------------------------
// 4  pcname error ,macaddr OK
// 6  pcname error , macaddr no check
// 8@macaddr error ,pcname ok
// 9  macaddr error ,pcname no check
// 12 pcname error,macaddr error
var
  DataSnap: TServerMethods1Client;
begin
  try
    u01ClientMain.fm_Main.SQLConnection1.Open;
    DataSnap := u07ClientDataSnap.TServerMethods1Client.create
      (u01ClientMain.fm_Main.SQLConnection1.DBXConnection);
    result := DataSnap.pcCheck(pcName, macAddr, ipAddr);
    unyolog(pcName, macAddr, ipAddr, 'PcCheck result:' + inttostr(result));
    DataSnap.Free;
  except
  end;
end;

function TClientLogic.backup: boolean;
// ==========================================================================//
// obNAbv
// ==========================================================================//
var
  SF: TextFile;
  SL1, SL2: TStringList; // SL1:ۑ@SL2F폜
  dt3: TDateTime; // DT1Ff[^ۑADT2FobNAbvۑ
  buf: string;
  I: integer;
begin
  dt3 := now - cc_LogDeleteDays;

  // Ot@C̐
  if FileExists(cc_LogFileName) then
    begin
      try
        AssignFile(SF, cc_LogFileName);
        SL1 := TStringList.create;
        SL2 := TStringList.create;
        Reset(SF);
        while not eof(SF) do
          begin
            ReadLn(SF, buf);
            if StrToDateTime(csvValue(buf, 0)) >= dt3 then
              SL1.Add(buf)
            else
              SL2.Add(buf);
          end;
        CloseFile(SF);

        if SL2.count > 0 then
          begin
            SL1.SaveToFile(cc_LogFileName);
          end;

      finally
        SL1.Free;
        SL2.Free;
      end;
    end
  else
    begin
      AssignFile(SF, cc_LogFileName);
      Rewrite(SF);
      CloseFile(SF);
      result := false;
    end;
end;

function TClientLogic.csvValue(str: string; n: integer): string;
// ==========================================================================//
// CSVeLXg炎Ԗڂ̒l擾
// ==========================================================================//
var
  CL: TStringList;
begin
  CL := TStringList.create;
  CL.Delimiter := #9; // TAB
  CL.StrictDelimiter := true;
  CL.DelimitedText := str;
  if CL.count <= n then
    result := ''
  else
    result := CL.Strings[n];
  CL.Free;
end;


function TClientLogic.GetIpAdress(): string;
// ==========================================================================//
// IPAhX̎擾
// ==========================================================================//
var
  IdUDP: TIdUDPClient;
begin
  IdUDP := TIdUDPClient.create(nil);
  result := GStack.LocalAddress;
  IdUDP.Free;
end;

function TClientLogic.GetHostName(): string;
// ==========================================================================//
// zXgiPCj̎擾
// ==========================================================================//
var
  IdUDP: TIdUDPClient;
begin
  IdUDP := TIdUDPClient.create(nil);
  result := GStack.hostName;
  IdUDP.Free;
end;

function SendARP(DestIp: DWORD; srcIP: DWORD; pMacAddr: pointer;
  PhyAddrLen: pointer): DWORD; stdcall; external 'iphlpapi.dll';
// ==========================================================================//
// IPAhXMACAhX̎擾[`@}CN\tg
// ==========================================================================//

function TClientLogic.GetMACAdress(IPAddress: string): string;
// ==========================================================================//
// MACAhX̎擾
// ==========================================================================//
var
  MACAddress: string;
  RC: DWORD;
  AnsiIPAddress: AnsiString;
  dwRemoteIP: DWORD;
  PhyAddrLen: Longword;
  pMacAddr: array [0 .. 1] of Longword;
  temp: array [0 .. 5] of Byte;
  I: Byte;
begin
  result := '';
  AnsiIPAddress := AnsiString(IPAddress);
  dwRemoteIP := inet_addr(PAnsiChar(AnsiIPAddress));
  if dwRemoteIP <> 0 then
    begin
      PhyAddrLen := 6;
      RC := SendARP(dwRemoteIP, 0, @pMacAddr, @PhyAddrLen);
      if RC = NO_ERROR then
        begin
          if (PhyAddrLen <> 0) and (pMacAddr[0] <> 0) then
            begin
              Move(pMacAddr, temp, 6);
              MACAddress := '';
              for I := 0 to PhyAddrLen - 1 do
                begin
                  MACAddress := MACAddress + IntToHex(temp[I], 2) + '-';
                end;
              delete(MACAddress, length(MACAddress), 1);
              result := MACAddress;
            end;
        end;
    end;
end;

function TClientLogic.getServerTime: string;
// ==========================================================================//
// T[o[Ԃ̎擾
// ==========================================================================//
var
  DataSnap: TServerMethods1Client;
begin
  try
    DataSnap := u07ClientDataSnap.TServerMethods1Client.create
      (fm_Main.SQLConnection1.DBXConnection);
    result := DataSnap.getDateTime();
    DataSnap.Free;
  except
  end;
end;
end.
