// 
unit u03config;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, u07ClientDataSnap,
  ShlObj, ActiveX, ComObj;

type
  Tfm_config2 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    ed_HostName: TEdit;
    ed_Port: TComboBox;
    ed_checkInterval: TComboBox;
    ed_LogFileName: TEdit;
    ed_LogDeleteDays: TComboBox;
    bt_OK: TButton;
    bt_Cancel: TButton;
    ed_sender: TEdit;
    Label8: TLabel;
    ed_groupName: TComboBox;
    mm_Keyword: TMemo;
    bt_startup: TButton;
    procedure bt_OKClick(Sender: TObject);
    procedure bt_CancelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bt_startupClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  fm_config2: Tfm_config2;

implementation

uses u01ClientMain;

{$R *.dfm}

procedure Tfm_config2.FormCreate(Sender: TObject);
// ==========================================================================//
// ݒtH[@
// ==========================================================================//
var
  SL: TStringList;
begin
  ed_checkInterval.Text := IntToStr(ClientLogic.cc_CheckInterval);

  SL := TStringList.create;
  SL.Delimiter := #9;
  SL.DelimitedText := ClientLogic.getGroupName;
  ed_groupName.Items.AddStrings(SL);
  ed_groupName.Text := ClientLogic.cc_GroupName;

  ed_HostName.Text := ClientLogic.cc_HostName;
  mm_Keyword.Text := ClientLogic.TextToMemo(ClientLogic.cc_Keyword);
  ed_LogDeleteDays.Text := IntToStr(ClientLogic.cc_LogDeleteDays);
  ed_LogFileName.Text := ClientLogic.cc_LogFileName;
  ed_Port.Text := IntToStr(ClientLogic.cc_Port);
  ed_sender.Text := ClientLogic.cc_sender;

end;

procedure Tfm_config2.bt_OKClick(Sender: TObject);
// ==========================================================================//
// ݒ@OK
// ==========================================================================//
begin
  ClientLogic.cc_CheckInterval := StrToInt(ed_checkInterval.Text);
  ClientLogic.cc_GroupName := ed_groupName.Text;
  ClientLogic.cc_HostName := ed_HostName.Text;
  ClientLogic.cc_Keyword := ClientLogic.MemoToText(mm_Keyword.Text);
  ClientLogic.cc_LogDeleteDays := StrToInt(ed_LogDeleteDays.Text);
  ClientLogic.cc_LogFileName := ed_LogFileName.Text;
  ClientLogic.cc_Port := StrToInt(ed_Port.Text);
  ClientLogic.cc_sender := ed_sender.Text;

  u01ClientMain.fm_Main.SQLConnection1.Params.Values['HostName'] :=
    ClientLogic.cc_HostName;
  u01ClientMain.fm_Main.SQLConnection1.Params.Values['Port'] :=
    IntToStr(ClientLogic.cc_Port);
  u01ClientMain.fm_Main.SQLConnection1.Connected := false;

  if ClientLogic.networkError = false then
    u01ClientMain.fm_Main.SQLConnection1.Connected := True;

  if u01ClientMain.fm_Main.SQLConnection1.Connected then
    ClientLogic.unyolog2('Client restart OK [' + ClientLogic.cc_HostName + '/' +
      IntToStr(ClientLogic.cc_Port) + ']')
  else
    ClientLogic.unyolog2('Client restart NG [' + ClientLogic.cc_HostName + '/' +
      IntToStr(ClientLogic.cc_Port) + ']');

  ClientLogic.iniFileWrite;
  ClientLogic.unyolog2('config update');

  fm_config2.Close;

end;

function GetStartupFolder: string;
var Path: array [0 .. MAX_PATH] of Char; pidl: PItemIDList;
begin
  SHGetSpecialFolderLocation(Application.Handle, CSIDL_STARTUP, pidl);
  SHGetPathFromIDList(pidl, Path);
  Result := Path;
end;

function GetFolderName: string;
begin
  Result := ExtractFilePath(ParamStr(0));
end;

function GetExeName: string;
begin
  Result := StringReplace(ParamStr(0), ExtractFilePath(ParamStr(0)), '', [rfReplaceAll]);
end;

function CreateShortCut(ShortcutPath, ExecFilePath, SavePath: string): boolean;
var SL: IShelllink; PF: IPersistFile; wFileName: WideString;
begin
  Result := false;
  SL := CreateComObject(CLSID_ShellLink) as IShelllink;
  PF := SL as IPersistFile;
  if SL.SetPath(PChar(ExecFilePath)) <> NOERROR then Abort;
  if SL.SetWorkingDirectory(PChar(ExtractFilePath(ExecFilePath))) <> NOERROR then Abort;
  wFileName := SavePath + '\' + ChangeFileExt(ExtractFileName(ShortcutPath), '') + '.lnk';
  if PF.Save(PWChar(wFileName), false) <> NOERROR then Abort;
  Result := true;
end;

procedure Tfm_config2.bt_startupClick(Sender: TObject);
// ==========================================================================//
// X^[gAbvo^
// ==========================================================================//
var ShortcutPath: string;
begin
  ShortcutPath := GetExeName;
  if CreateShortCut(ShortcutPath, GetFolderName + GetExeName, GetStartupFolder) then begin
    showmessage('o^');
  end
  else showmessage('o^s');

end;

procedure Tfm_config2.bt_CancelClick(Sender: TObject);
// ==========================================================================//
// LZ
// ==========================================================================//
begin
  ed_checkInterval.Text := IntToStr(ClientLogic.cc_CheckInterval);
  ed_groupName.Text := ClientLogic.cc_GroupName;
  ed_HostName.Text := ClientLogic.cc_HostName;
  mm_Keyword.Text := ClientLogic.TextToMemo(ClientLogic.cc_Keyword);
  ed_LogDeleteDays.Text := IntToStr(ClientLogic.cc_LogDeleteDays);
  ed_LogFileName.Text := ClientLogic.cc_LogFileName;
  ed_Port.Text := IntToStr(ClientLogic.cc_Port);
  ed_sender.Text := ClientLogic.cc_sender;

  fm_config2.Close;

end;

end.
