// 
unit u04ClientMsgList;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.Grids,
  u02ClientLogic, u07ClientDataSnap, StrUtils,
  dxAlertWindow, cxGraphics, cxLookAndFeelPainters, Vcl.Menus, Clipbrd,
  Vcl.ImgList;

type
  Tfm_msgList = class(TForm)
    StringGrid1: TStringGrid;
    bt_update: TButton;
    lb_msgCount: TLabel;
    Panel1: TPanel;
    dxAlertWindowManager1: TdxAlertWindowManager;
    PopupMenu2: TPopupMenu;
    N5: TMenuItem;
    cxImageList1: TcxImageList;
    procedure FormCreate(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure StringGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bt_updateClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure StringGrid1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure N5Click(Sender: TObject);
     function GetCurrentMessage(AAlertWindow: TdxAlertWindow)
      : TdxAlertWindowMessage;
  private
  public
  end;

var
  fm_msgList: Tfm_msgList;
  SL, ML: TStringList; // SL IWiXg@ML@\pXg

implementation

uses u01ClientMain;

{$R *.dfm}

procedure Tfm_msgList.FormCreate(Sender: TObject);
// ==========================================================================//
// tH[
// ==========================================================================//
var
  i: Integer;
  DataSnap: TServerMethods1Client;
begin
  StringGrid1.RowCount := 0;
  StringGrid1.refresh;
  StringGrid1.ColWidths[0] := 500;
  StringGrid1.DefaultDrawing := FALSE;
  StringGrid1.DefaultRowHeight := 56;
  StringGrid1.ColCount := 1;
  StringGrid1.ScrollBars := ssVertical;

  if ClientLogic.networkError = FALSE then
    SL := ClientLogic.getFullMsgList2(ClientLogic.cc_GroupName)
  else
    SL := TStringList.create;
  begin

  end;
  ML := ClientLogic.MsgList(SL);
  StringGrid1.RowCount := SL.Count;
  for i := 0 to ML.Count - 1 do
    begin
      StringGrid1.Cells[0, i] := ML.Strings[i];
    end;
  lb_msgCount.Caption := IntToStr(StringGrid1.Row + 1) + '/' +
    IntToStr(StringGrid1.RowCount);
end;

procedure Tfm_msgList.bt_updateClick(Sender: TObject);
// ==========================================================================//
// XV
// ==========================================================================//
var
  topRow, Row: Integer;
begin
  topRow := StringGrid1.topRow;
  Row := StringGrid1.Row;
  FormCreate(nil);
  if StringGrid1.RowCount >= topRow then
    StringGrid1.topRow := topRow
  else
    StringGrid1.topRow := StringGrid1.RowCount;

  if StringGrid1.RowCount > Row then
    StringGrid1.Row := Row
  else
    StringGrid1.Row := StringGrid1.RowCount - 1;
  StringGrid1.SetFocus;
end;

procedure Tfm_msgList.FormShow(Sender: TObject);
// ==========================================================================//
// bZ[WtH[\
// ==========================================================================//
begin
  FormCreate(nil);
end;

function Tfm_msgList.GetCurrentMessage(
  AAlertWindow: TdxAlertWindow): TdxAlertWindowMessage;
// ==========================================================================//
// fXNgbvʒmFNbv{[hւ̃Rs[p̃JgbZ[W̎擾
// ==========================================================================//
begin
  Result := AAlertWindow.MessageList[AAlertWindow.CurrentMessageIndex];
end;

procedure Tfm_msgList.N5Click(Sender: TObject);
begin
  Clipboard.AsText := GetCurrentMessage
    (PopupMenu2.PopupComponent as TdxAlertWindow).Text;
end;

procedure Tfm_msgList.StringGrid1DrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
// ==========================================================================//
// XgOObh@\
// ==========================================================================//
var
  s: array [0 .. 5000] of Char;
begin
  with StringGrid1.Canvas do
    begin
      Font := StringGrid1.Font;

      if gdFocused in State then
        begin
          Brush.Color := clSkyBlue;
          DrawFocusRect(Rect);
        end
      else
        begin
          Brush.Color := clWhite;
        end;

      FillRect(Rect);
      StrPCopy(s, StringGrid1.Cells[Col, Row]);
      DrawText(StringGrid1.Canvas.Handle, s, -1, Rect, DT_WORDBREAK);

      lb_msgCount.Caption := RightStr('0000' + IntToStr(StringGrid1.Row + 1), 4)
        + '/' + RightStr('0000' + IntToStr(StringGrid1.RowCount), 4);

    end;
end;

procedure Tfm_msgList.StringGrid1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
// ==========================================================================//
// L[_E
// ==========================================================================//
var
  strDt, strRandam: string;
  tempDT: TDateTime;
  tempRandam: Integer;
  topRow, Row: Integer;
  mac1, mac2: string;
begin
  if (Key = VK_DELETE) then
    begin
      strDt := u01ClientMain.ClientLogic.csvValue
        (SL.Strings[StringGrid1.Row], 1);
      strRandam := u01ClientMain.ClientLogic.csvValue
        (SL.Strings[StringGrid1.Row], 7);
      topRow := StringGrid1.topRow;
      Row := StringGrid1.Row;

      // PC̃bZ[W
      mac1 := u01ClientMain.ClientLogic.csvValue
        (SL.Strings[StringGrid1.Row], 9);
      mac2 := u01ClientMain.ClientLogic.GetMACAdress(ClientLogic.GetIpAdress);

      if mac1 = mac2 then
        begin

          if MessageDlg('폜܂H', mtWarning, [mbYes, mbNo], 0) = mrYes then
            begin
              tempDT := StrToDateTime(strDt);
              tempRandam := strtoint(strRandam);
              if u01ClientMain.ClientLogic.DeleteMsg(tempDT, tempRandam) then
                begin
                  FormCreate(nil);
                  if StringGrid1.RowCount >= topRow then
                    StringGrid1.topRow := topRow
                  else
                    StringGrid1.topRow := StringGrid1.RowCount;
                  if StringGrid1.RowCount > Row then
                    StringGrid1.Row := Row
                  else
                    StringGrid1.Row := StringGrid1.RowCount - 1;
                end;
            end;

        end;

    end;

  if (Key = VK_RETURN) then
    begin
          dxAlertWindowManager1.show('[' + ClientLogic.csvValue(SL.Strings[StringGrid1.Row],
            4) + '] ' + ClientLogic.csvValue(SL.Strings[StringGrid1.Row], 5) + '@' +
            ClientLogic.csvValue(SL.Strings[StringGrid1.Row], 1) + '@' +
            ClientLogic.csvValue(SL.Strings[StringGrid1.Row], 11),
            ClientLogic.TextToMemo(ClientLogic.csvValue(SL.Strings[StringGrid1.Row], 3)),
            strToInt(ClientLogic.csvValue(SL.Strings[StringGrid1.Row], 6)));
    end;
end;

procedure Tfm_msgList.StringGrid1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
// ==========================================================================//
// XgOObh@}EX_E
// ==========================================================================//
var
  strDt, strRandam: string;
  tempDT: TDateTime;
  tempRandam: Integer;
  topRow, Row: Integer;
  mac1, mac2: string;
begin
  if Button = mbRight then
    begin
      strDt := u01ClientMain.ClientLogic.csvValue
        (SL.Strings[StringGrid1.Row], 1);
      strRandam := u01ClientMain.ClientLogic.csvValue
        (SL.Strings[StringGrid1.Row], 7);
      topRow := StringGrid1.topRow;
      Row := StringGrid1.Row;

      // PC̃bZ[W
      mac1 := u01ClientMain.ClientLogic.csvValue
        (SL.Strings[StringGrid1.Row], 9);
      mac2 := u01ClientMain.ClientLogic.GetMACAdress(ClientLogic.GetIpAdress);

      if mac1 = mac2 then
        begin

          if MessageDlg('폜܂H', mtWarning, [mbYes, mbNo], 0) = mrYes then
            begin
              tempDT := StrToDateTime(strDt);
              tempRandam := strtoint(strRandam);

              if u01ClientMain.ClientLogic.DeleteMsg(tempDT, tempRandam) then
                begin
                  FormCreate(nil);
                  if StringGrid1.RowCount >= topRow then
                    StringGrid1.topRow := topRow
                  else
                    StringGrid1.topRow := StringGrid1.RowCount;
                  if StringGrid1.RowCount > Row then
                    StringGrid1.Row := Row
                  else
                    StringGrid1.Row := StringGrid1.RowCount - 1;
                end;
            end;
        end;

    end
  else
    begin
          dxAlertWindowManager1.show('[' + ClientLogic.csvValue(SL.Strings[StringGrid1.Row],
            4) + '] ' + ClientLogic.csvValue(SL.Strings[StringGrid1.Row], 5) + '@' +
            ClientLogic.csvValue(SL.Strings[StringGrid1.Row], 1) + '@' +
            ClientLogic.csvValue(SL.Strings[StringGrid1.Row], 11),
            ClientLogic.TextToMemo(ClientLogic.csvValue(SL.Strings[StringGrid1.Row], 3)),
            strToInt(ClientLogic.csvValue(SL.Strings[StringGrid1.Row], 6)));
    end;
end;

end.
